

 //pin
 
 const byte pin_uscita = 9; //pin di output

 //variabili globali
 byte lettura = 0; //contiene il valore che sarà inviato al pin 9

 void setup() {
   Serial.begin(9600); // apro la seriale a 9600 bit/sec, anche la trasmissione dei 
   // caratteri deve avvenire alla stessa velocità
     }

//programma principale
 void loop() {
   int lettura; //contiene il valore di PWM letto dalla seriale
   unsigned long tempo_in_millisecondi; //serve per il timeout sulla ricezione del valore di PWM
   // unsigned long definisce una variabile numerica, cioè un numero a 32 bit max (2^32 - 1)
   
   byte i; //contiene il numero di caratteri ricevuti
   byte CarattereLetto; //contiene il carattere letto
   
     //controllo se c'è qualcosa in arrivo sulla seriale
   if (Serial.available()) {
         lettura = 0;
        tempo_in_millisecondi = millis(); //da questo istante si comincia a contare
        // il tempo trascorso ( in millisecondi ) e lo si assegna alla variabile tempo_in_millisecondi
        
         i = 0;
         // i conta il numero dei caratteri
         do {
           if (Serial.available()) {
             CarattereLetto = Serial.read();
             i++; //vado avanti di 1 con il conteggio dei caratteri letti dalla seriale
             // il 48 corrisponde al numero 0 e 57 a 9
             if ((CarattereLetto >= 48) && (CarattereLetto <= 57)) { //è un numero? ok
               lettura = (lettura * 10) + (CarattereLetto - 48);
 // es: inizialmente "lettura = 0 ", CarattereLetto = 49 ( è il num. 1 ) -> lettura = 1
 // secondo ciclo: CarattereLetto = 56 ( è il num. 8 ) -> lettura = 10 + 8 = 18
 // terzo ciclo: CarattereLetto = 51 ( 3 ) -> lettura = 180 + 3 = 183
 // il "trasmettitore" deve quindi mandare prima la cifra delle 
 // centinaia, poi decine, poi unità, cioè leggere da sinistra a destra    
              } 
           }
         //esco sia per timeout,sia per un valore di PWM maggiore di 255
         //sia per troppi caratteri ricevuti : i = 10
         } while((millis() - tempo_in_millisecondi < 50) && (lettura <= 255) && (i < 10));
 // millis() - tempo_in_millisecondi < di un certo numero di ms è una verifica indispensabile
 // senza la quale il programma non funziona, la causa: mistero della seriale
 // o del suo buffer 
 //se il valore di PWM è valido, lo imposto sul pin di uscita
         // && è un AND 
         
         if (lettura <= 255) {
                      analogWrite(pin_uscita, lettura);
  // analogWrite fornisce una uscita PWM sul pin desiderato con duty cycle 
  // dipendente dal valore (lettura nel mio caso). Il valore può variare 
  // da 0 a 255.
         }
        svuotaBuffer(); // chiamo una subroutine 
   }
 }
 void svuotaBuffer() {
  while (Serial.available()) {
    byte temp = Serial.read(); // i caratteri presenti nel buffer dovrebbero 
    // andare tutti nella variabile temp ??
  }
}
